﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default" %>

<%@ Register Assembly="RadAjax.Net2" Namespace="Telerik.WebControls" TagPrefix="rad" %>

<%@ Register Assembly="RadGrid.Net2" Namespace="Telerik.WebControls" TagPrefix="rad" %>
<%@ Register Assembly="RadMenu.Net2" Namespace="Telerik.WebControls" TagPrefix="rad" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Hierarchical RadGrid with context menu</title>
</head>
<body>
    <form id="Form1" method="post" runat="server">

        <script type="text/javascript">
            function RowContextMenu(index, e)
            {
               if(this.Rows[index].ItemType != "NestedView")
               { 
                 var menu = <%= RadMenu1.ClientID %>;
                 document.getElementById("radGridClickedRowIndex").value = this.Rows[index].RealIndex;
                 document.getElementById("radGridClickedTableId").value = this.UID;

                 menu.Show(e);
                
                 e.cancelBubble = true;
                 e.returnValue = false;

                 if (e.stopPropagation)
                 {
                   e.stopPropagation();
                   e.preventDefault();
                 }
               } 
            }
        </script>
        <rad:RadAjaxManager ID="RadAjaxManager1" runat="server" >
            <AjaxSettings>
                <rad:AjaxSetting AjaxControlID="RadMenu1">
                    <UpdatedControls>
                        <rad:AjaxUpdatedControl ControlID="RadMenu1" />
                        <rad:AjaxUpdatedControl ControlID="RadGrid2" LoadingPanelID="AjaxLoadingPanel1" />
                    </UpdatedControls>
                </rad:AjaxSetting>
                <rad:AjaxSetting AjaxControlID="RadGrid2">
                    <UpdatedControls>
                        <rad:AjaxUpdatedControl ControlID="RadMenu1" />
                        <rad:AjaxUpdatedControl ControlID="RadGrid2" LoadingPanelID="AjaxLoadingPanel1" />
                    </UpdatedControls>
                </rad:AjaxSetting>
            </AjaxSettings>
        </rad:RadAjaxManager>
        <rad:AjaxLoadingPanel ID="AjaxLoadingPanel1" runat="server" Height="75px"
         Transparency="25" Width="75px">
                <asp:Image ID="Image1" runat="server" AlternateText="Loading..." ImageUrl="~/RadControls/Ajax/Skins/Default/Loading.gif" />
            </rad:AjaxLoadingPanel>
        <input type="hidden" id="radGridClickedRowIndex" name="radGridClickedRowIndex">
        <input type="hidden" id="radGridClickedTableId" name="radGridClickedTableId">
        <p>
            Right-click the grid to open context menu</p>
        <rad:RadMenu ID="RadMenu1" IsContext="True" runat="server" Skin="Outlook" ContextMenuElementID="none"
            OnItemClick="RadMenu1_ItemClick">
            <Items>
                <rad:RadMenuItem Text="Select">
                </rad:RadMenuItem>
                <rad:RadMenuItem Text="Edit">
                </rad:RadMenuItem>
            </Items>
        </rad:RadMenu>
        <rad:RadGrid ID="RadGrid2" runat="server" Width="95%" AutoGenerateColumns="False"
            PageSize="3" AllowSorting="True" AllowPaging="True" DataSourceID="AccessDataSource1"
            Skin="Glassy">
            <PagerStyle Mode="NumericPages" />
            <MasterTableView DataKeyNames="CustomerID" Width="100%" Name="Customers" DataSourceID="AccessDataSource1">
                <Columns>
                    <rad:GridBoundColumn HeaderText="CustomerID" DataField="CustomerID" HeaderButtonType="TextButton"
                        UniqueName="CustomerID" SortExpression="CustomerID">
                    </rad:GridBoundColumn>
                    <rad:GridBoundColumn HeaderText="Contact Name" DataField="ContactName" HeaderButtonType="TextButton"
                        UniqueName="ContactName" SortExpression="ContactName">
                    </rad:GridBoundColumn>
                    <rad:GridBoundColumn HeaderText="Company" DataField="CompanyName" HeaderButtonType="TextButton"
                        UniqueName="CompanyName" SortExpression="CompanyName">
                    </rad:GridBoundColumn>
                </Columns>
                <DetailTables>
                    <rad:GridTableView DataKeyNames="OrderID" Name="Orders" Width="100%" DataSourceID="AccessDataSource2">
                        <ParentTableRelation>
                            <rad:GridRelationFields DetailKeyField="CustomerID" MasterKeyField="CustomerID"></rad:GridRelationFields>
                        </ParentTableRelation>
                        <Columns>
                            <rad:GridBoundColumn HeaderText="OrderID" DataField="OrderID" HeaderButtonType="TextButton"
                                UniqueName="OrderID" SortExpression="OrderID">
                            </rad:GridBoundColumn>
                            <rad:GridBoundColumn HeaderText="Date Ordered" DataField="OrderDate" HeaderButtonType="TextButton"
                                UniqueName="OrderDate" SortExpression="OrderDate">
                            </rad:GridBoundColumn>
                            <rad:GridBoundColumn HeaderText="EmployeeID" DataField="EmployeeID" HeaderButtonType="TextButton"
                                UniqueName="EmployeeID" SortExpression="EmployeeID">
                            </rad:GridBoundColumn>
                        </Columns>
                        <DetailTables>
                            <rad:GridTableView DataKeyNames="OrderID" Name="OrderDetails" Width="100%" DataSourceID="AccessDataSource3">
                                <ParentTableRelation>
                                    <rad:GridRelationFields DetailKeyField="OrderID" MasterKeyField="OrderID"></rad:GridRelationFields>
                                </ParentTableRelation>
                                <Columns>
                                    <rad:GridBoundColumn HeaderText="Unit Price" DataField="UnitPrice" HeaderButtonType="TextButton"
                                        UniqueName="UnitPrice" SortExpression="UnitPrice">
                                    </rad:GridBoundColumn>
                                    <rad:GridBoundColumn HeaderText="Quantity" DataField="Quantity" HeaderButtonType="TextButton"
                                        UniqueName="Quantity" SortExpression="Quantity">
                                    </rad:GridBoundColumn>
                                    <rad:GridBoundColumn HeaderText="Discount" DataField="Discount" HeaderButtonType="TextButton"
                                        UniqueName="Discount" SortExpression="Discount">
                                    </rad:GridBoundColumn>
                                </Columns>
                            </rad:GridTableView>
                        </DetailTables>
                    </rad:GridTableView>
                </DetailTables>
            </MasterTableView>
            <ClientSettings>
                <ClientEvents OnRowContextMenu="RowContextMenu" />
            </ClientSettings>
        </rad:RadGrid>
        <br />
        <asp:AccessDataSource ID="AccessDataSource1" DataFile="~/App_Data/Nwind.mdb" SelectCommand="SELECT * FROM Customers"
            runat="server"></asp:AccessDataSource>
        <asp:AccessDataSource ID="AccessDataSource2" DataFile="~/App_Data/Nwind.mdb" SelectCommand="SELECT * FROM Orders Where CustomerID = ?"
            runat="server">
            <SelectParameters>
                <asp:SessionParameter Name="CustomerID" SessionField="CustomerID" Type="string" />
            </SelectParameters>
        </asp:AccessDataSource>
        <asp:AccessDataSource ID="AccessDataSource3" DataFile="~/App_Data/Nwind.mdb" SelectCommand="SELECT * FROM [Order Details] where OrderID = ?"
            runat="server">
            <SelectParameters>
                <asp:SessionParameter Name="OrderID" SessionField="OrderID" Type="Int32" />
            </SelectParameters>
        </asp:AccessDataSource>
    </form>
</body>
</html>
